/*****************************************************************************
*
* Atmel Corporation
*
* ̧			: g726_16.c
* ߲		: Microsoft Visual C++ 6.0
* 			: $Revision: 1.3 $
* t			: $Date: Thursday, September 23, 2004 13:21:14 UTC $
* XV		: $Author: kmeyer $
*
* xҰ		: avr@atmel.com
*
* x޲	: ATmega128/Windows PC (ANSICׂ߲̉\
*				  )
*
* pLq		: AVR336: ADPCM
*
* 			: ADPCMp40kbpsٰ݁B͉pLqԍ336:ADPCM
*				  ɑ΂⑫łB͂̕p̕ް𐶐
*				  ̂ɕKvƂ܂B
*
*				  ĳ̈ꕔSun Microsystem, Inc.ɂČ̏ɌJꂽ
*				  ނɊ܂B
*
****************************************************************************/

/*
 * ̿ ނSun Microsystems, Inc.̐iŖ̎gpɑ΂ċĂ
 * ܂Bgp҂͑㉿Ȃɂ̿ ނ𕡎ʂ܂͕ύXł܂B
 *
 * Sun̿ ނ͐݌vAsꐫA̖ړIɑ΂KA܂͎Agp@
 * Ɩ̐isNۏ؂܂߂āAǂ̎̕ۏ؂SȂA󂻂̂܂܂Œ
 * ܂B
 *
 * Sun̿ ނ͂̎gpACAύX܂͋ɉ鉇ɑ΂
 * Sun Microsystems, Inc.̈ꕔɉĂǂȐӖȂSxȂŒ񋟂
 * B
 *
 * Sun Microsystems, Inc.͂̿ĳ܂͂̉ꂩ̕ɂĒ쌠A
 * ̔閧A܂͉ꂩ̓̐NQɊւđSӔCȂł傤B
 *
 * ႦSun̂悤ȑQ̉\̐iĂƂĂASun Microsystems,
 * Inc.͂ǂȎꂽ◘vA܂͑̓ʂŁAԐړIŊKRIȑQ
 * ɂāAx̋`Ȃł傤
 *
 * Sun Microsystems, Inc.
 * 2550 Garcia Avenue
 * Mountain View, California  94043
 */

/*
 * g726_40.c
 *
 * :
 *
 * g726_40_encoder(), g726_40_decoder()
 *
 * ٰ݂͋͂ɕύXꂽITU-T G.726 40kbps ADPCMZ@̎琬
 * ܂B
 *
 */

#include "g72x.h"

/*
 * č\ꂽړxWWΐ傫lɑ΂G.726_40ꊄ蓖
 */
static short _dqlntab[32] = {-2048, -66, 28, 104, 169, 224, 274, 318,
							 358, 395, 429, 459, 488, 514, 539, 566,
							 566, 539, 514, 488, 459, 429, 395, 358,
							 318, 274, 224, 169, 104, 28, -66, -2048};

/* ړxW{̑ΐɑ΂G.726_40ꊄ蓖 */
static short _witab[32] = {448, 448, 768, 1248, 1280, 1312, 1856, 3200,
						   4512, 5728, 7008, 8960, 11456, 14080, 16928, 22272,
						   22272, 16928, 14080, 11456, 8960, 7008, 5728, 4512,
						   3200, 1856, 1312, 1280, 1248, 768, 448, 448};

/*
 * ZԕςvZAĐMÎ~(sϏ)ǂ̎w^邽
 * ɔrꂽl̑gɑ΂G.726_40ꊄ蓖
 */
static short _fitab[32] = {0, 0, 0, 0, 0, 0x200, 0x200, 0x200,
						   0x200, 0x200, 0x400, 0x600, 0x800, 0xA00, 0xC00, 0xC00,
						   0xC00, 0xC00, 0xA00, 0x800, 0x600, 0x400, 0x200, 0x200,
						   0x200, 0x200, 0x200, 0, 0, 0, 0, 0};

static short qtab_726_40[15] = {-122, -16, 68, 139, 198, 250, 298, 339,
								378, 413, 445, 475, 502, 528, 553};

/*
 * g726_40_encoder()
 *
 * 16ޯĒPCMAA-lawA-law͎̓𕄍Čʂ5ޯADPCMԂ܂
 * ͕̏ꍇ-1Ԃ܂B
 */
int
g726_40_encoder(
	int sl,
	int in_coding,
	struct g72x_state *state_ptr)
{
	short se, sez;		/* ACCUM */
	short d;			/* SUBTA */
	short y;			/* MIX */
	short sr;			/* ADDB */
	short dqsez;		/* ADDC */
	short dq, i;

	switch (in_coding) {						/* ͎14ޯPCMɒ */
	case AUDIO_ENCODING_ALAW:
		sl = alaw2linear((unsigned char) sl) >> 2;
		break;
	case AUDIO_ENCODING_ULAW:
		sl = ulaw2linear((unsigned char) sl) >> 2;
		break;
	case AUDIO_ENCODING_LINEAR:
		sl >>= 2;								/* ͈14ޯĐ */
		break;
	default:
		return (-1);
	}
	se = predictor(&sez, state_ptr);			/* se=\M */
	d = sl - se;								/* d=\ */
	/* \d̗ʎq */
	y = step_size(state_ptr);					/* KʎqiK */
	i = quantize(d, y, qtab_726_40, 15);		/* i=ADPCM */
	dq = reconstruct(i & 0x10, _dqlntab[i], y);	/* ʎq */
	sr = se + dq;								/* č\M */
	dqsez = sr + sez - se;						/* dqsez=ɗ\ */
	update(5, y, _witab[i], _fitab[i], dq, sr, dqsez, state_ptr);
	return (i);
}

/*
 * g726_40_decoder()
 *
 * 5ޯADPCM𕜍Čʂ16ޯĒPCMAA-lawA܂̓-law̎l
 * ܂B
 * o͕m̏ꍇ-1Ԃ܂B
 */
int
g726_40_decoder(
	int i,
	int out_coding,
	struct g72x_state *state_ptr)
{
	short sez, se;		/* ACCUM */
	short y;			/* MIX */
	short sr;			/* ADDB */
	short dq;
	short dqsez;

	i &= 0x1f;										/* ޯĂ𓾂邽߂ɎՕ */
	se = predictor(&sez, state_ptr);				/* se=\M */
	y = step_size(state_ptr);						/* KʎqiK */
	dq = reconstruct(i & 0x10, _dqlntab[i], y);		/* \ */
	sr = se + dq;									/* č\M */
	dqsez = sr - se + sez;							/* ɗ\ */
	update(5, y, _witab[i], _fitab[i], dq, sr, dqsez, state_ptr);
	switch (out_coding) {
	case AUDIO_ENCODING_ALAW:
		return (tandem_adjust_alaw(sr, se, y, i, 0x10, qtab_726_40));
	case AUDIO_ENCODING_ULAW:
		return (tandem_adjust_ulaw(sr, se, y, i, 0x10, qtab_726_40));
	case AUDIO_ENCODING_LINEAR:
		return (sr << 2);							/* sr14ޯĊ͈͂̂ŉ */
	default:
		return (-1);
	}
}
