/*****************************************************************************
*
* Atmel Corporation
*
* ̧			: g726_16.c
* ߲		: Microsoft Visual C++ 6.0
* 			: $Revision: 1.3 $
* t			: $Date: Thursday, September 23, 2004 13:20:42 UTC $
* XV		: $Author: kmeyer $
*
* xҰ		: avr@atmel.com
*
* x޲	: ATmega128/Windows PC (ANSICׂ߲̉\
*				  )
*
* pLq		: AVR336: ADPCM
*
* 			: ADPCMpSٰ݁B͉pLqԍ336:ADPCM
*				  ɑ΂⑫łB͂̕p̕ް𐶐
*				  ɕKvƂ܂B
*
*				  ĳ̈ꕔSun Microsystem, Inc.ɂČ̏ɌJꂽ
*				  ނɊ܂B
*
****************************************************************************/

/*
 * ̿ ނSun Microsystems, Inc.̐iŖ̎gpɑ΂ċĂ
 * ܂Bgp҂͑㉿Ȃɂ̿ ނ𕡎ʂ܂͕ύXł܂B
 *
 * Sun̿ ނ͐݌vAsꐫA̖ړIɑ΂KA܂͎Agp@
 * Ɩ̐isNۏ؂܂߂āAǂ̎̕ۏ؂SȂA󂻂̂܂܂Œ
 * ܂B
 *
 * Sun̿ ނ͂̎gpACAύX܂͋ɉ鉇ɑ΂
 * Sun Microsystems, Inc.̈ꕔɉĂǂȐӖȂSxȂŒ񋟂
 * B
 *
 * Sun Microsystems, Inc.͂̿ĳ܂͂̉ꂩ̕ɂĒ쌠A
 * ̔閧A܂͉ꂩ̓̐NQɊւđSӔCȂł傤B
 *
 * ႦSun̂悤ȑQ̉\̐iĂƂĂASun Microsystems,
 * Inc.͂ǂȎꂽ◘vA܂͑̓ʂŁAԐړIŊKRIȑQ
 * ɂāAx̋`Ȃł傤
 *
 * Sun Microsystems, Inc.
 * 2550 Garcia Avenue
 * Mountain View, California  94043
 */

/*
 * g72x.c
 *
 * G.721G.723̕ϊpٰ̋
 */


#include <stdlib.h>

#include "g72x.h"

static short power2[15] = {1, 2, 4, 8, 0x10, 0x20, 0x40, 0x80,
						   0x100, 0x200, 0x400, 0x800, 0x1000, 0x2000, 0x4000};

/*
 * quan()
 *
 * Z^̑傫̕\ɑ΂ē͒lʎq܂B
 * table[i - 1]valtable[i]ȂAiԂ܂B
 *
 * Pȕ̂߂ɒgp܂B
 */
static int
quan(
	int val,
	short *table,
	int size)
{
	int i;

	for (i = 0; i < size; i++)
		if (val < *table++)
			break;
	return (i);
}

/*
 * predictor()
 *
 * AVR̗݊\zٰ
 *
 */

short predictor(short *sez, struct g72x_state *state_ptr){

  long int sezi;
  long int tmp;

  tmp = (long)state_ptr->b[0] * (long)state_ptr->dq[0];
  sezi = tmp;
  tmp = (long)state_ptr->b[1] * (long)state_ptr->dq[1];
  sezi += tmp;
  tmp = (long)state_ptr->b[2]  * (long)state_ptr->dq[2];
  sezi += tmp;
  tmp = (long)state_ptr->b[3]  * (long)state_ptr->dq[3];
  sezi += tmp;
  tmp = (long)state_ptr->b[4]  * (long)state_ptr->dq[4];
  sezi += tmp;
  tmp = (long)state_ptr->b[5]  * (long)state_ptr->dq[5];
  sezi += tmp;

  *sez = (short) (sezi >> 18);

  tmp = (long)state_ptr->a[0] * (long)state_ptr->sr[0];
  sezi += tmp;
  tmp = (long)state_ptr->a[1] * (long)state_ptr->sr[1];
  sezi += tmp;

  sezi = sezi >> 18;
  return ((short) sezi);
}

/*
 * g72x_init_state()
 *
 * ٰ݂'state_ptr'ɂĎwg72x̏ԍ\̂܂ؾĂ
 * ܂B
 * SĂ̏ԒlCCITT G.721Ŏw肳Ă܂B
 */
void
g72x_init_state(
	struct g72x_state *state_ptr)
{
	int cnta;

	state_ptr->yl = 34816;
	state_ptr->yu = 544;
	state_ptr->dms = 0;
	state_ptr->dml = 0;
	state_ptr->ap = 0;
	for (cnta = 0; cnta < 2; cnta++) {
		state_ptr->a[cnta] = 0;
		state_ptr->pk[cnta] = 0;
		state_ptr->sr[cnta] = 32;
	}
	for (cnta = 0; cnta < 6; cnta++) {
		state_ptr->b[cnta] = 0;
		state_ptr->dq[cnta] = 32;
	}
	state_ptr->td = 0;
}

/*
 * step_size()
 *
 * Kʎq̗ʎqiKʂvZ܂B
 *
 */
int
step_size(
	struct g72x_state *state_ptr)
{
	int y;
	int dif;
	int al;

	if (state_ptr->ap >= 256)
		return (state_ptr->yu);
	else {
		y = state_ptr->yl >> 6;
		dif = state_ptr->yu - y;
		al = state_ptr->ap >> 2;
		if (dif > 0)
			y += (dif * al) >> 6;
		else if (dif < 0)
			y += (dif * al + 0x3F) >> 6;
		return (y);
	}
}

/*
 * quantize()
 *
 * M̐'d'ƗʎqiKʎړxW'y'^ƁAٰ݂͂̎
 * ʎqꂽADPCMԂ܂BZƂđΐ2̈ŒiKʎړxW
 * Z삪s܂B
 */
int
quantize(
	int d,			/* M */
	int y,			/* iKʔ{ */
	short *table,	/* ʎq\ */
	int size)		/* Z^̕\e */
{
	short dqm;		/* 'd'̑傫 */
	short exp;		/* 'd'̒2̑ΐ̐ */
	short mant;		/* 'd'̒2̑ΐ̏ */
	short dl;		/* 'd'̑傫̑ΐ */
	short dln;		/* Wΐ̒iKʎړxW */
	int i;

	/*
	 * LOG
	 *
	 * 'd'̒2̑ΐvZ'dl'Ɋi[
	 */
	dqm = abs(d);
	exp = quan(dqm >> 1, power2, 15);
	mant = ((dqm << 7) >> exp) & 0x7F;		/*  */
	dl = (exp << 7) + mant;

	/*
	 * SUBTB
	 *
	 * iKʔ{ɂ"Z"
	 */
	dln = dl - (y >> 2);

	/*
	 * QUAN
	 *
	 * 'd'Ɋւ镄i擾
	 */
	if (size == 2){
		if(dln <= table[0])
			i = 0;
		else 
			i = 1;
		if (d < 0 && i == 0)
			i = 3;
		else if (d < 0)
			i = 2;
		return (i);
	} else {
		i = quan(dln, table, size);
		if (d < 0)							/* !1̕␔擾 */
			return ((size << 1) + 1 - i);
		else if (i == 0)					/* 01̕␔擾 */
			return ((size << 1) + 1);		/* 1988Nł̐VK */
		else
			return (i);
	}

}
/*
 * reconstruct()
 *
 * 'i'ƗʎqiKʎړxW'y'瓾č\M'dq'Ԃ܂B
 * Z͑ΐ2̈ŉZƂĎs܂B
 */
int
reconstruct(
	int sign,	/* :̒lɑ΂0 */
	int dqln,	/* G.72x */
	int y)		/* iKʔ{ */
{
	short dql;	/* 'dq'̑傫̑ΐ */
	short dex;	/* ΐ̐ */
	short dqt;
	short dq;	/* č\M */

	dql = dqln + (y >> 2);	/* ADDA */

	if (dql < 0) {
		return ((sign) ? -1 : 0);
	} else {		/* ANTILOG */
		dex = (dql >> 7) & 15;
		dqt = 128 + (dql & 127);
		dq = (dqt << 7) >> (14 - dex);
		return ((sign) ? -dq : dq);
	}
}

/*
 * update()
 *
 * eo͕ɑ΂ďԕϐXV
 */
void
update(
	int code_size,					/* ̑723_40 */
	int y,							/* ʎqiK */
	int wi,							/* ړxW{ */
	int fi,							/* /ZԴٷްp */
	int dq,							/* ʎq\z */
	int sr,							/* č\M */
	int dqsez,						/* 2ɗ\z̍ */
	struct g72x_state *state_ptr)	/* Ԉʒuwq */
{
	int cnt;
	short mag;						/* K\, FLOAT A */
	short a2p;						/* LIMC */
	short a1ul;						/* UPA1 */
	short pks1;						/* UPA2 */
	short fa1;
	char tr;						/* /Jڌo */
	short ylint, thr2, dqthr;
	short ylfrac, thr1;
	short pk0;

	pk0 = (dqsez < 0) ? 1 : 0;		/* \ɍXVŕKv */

	mag = abs(dq);

	/* TRANS */
	ylint = (short) (state_ptr->yl >> 15);	/* yl̎w */
	ylfrac = (state_ptr->yl >> 10) & 0x1F;	/* yl̏ */
	thr1 = (32 + ylfrac) << ylint;			/* 臒l */
	thr2 = (ylint > 9) ? 31 << 10 : thr1;	/* 31<<10ɐ */
	dqthr = (thr2 + (thr2 >> 1)) >> 1;		/* dqthr=0.75~thr2 */
	if (state_ptr->td == 0)					/* M͉ */
		tr = 0;
	else if (mag <= dqthr)					/* ްƉ肷邯ǁA傫̂ŁA */
		tr = 0;								/* ƂĎ舵 */
	else									/* Mް(ϕ) */
		tr = 1;

	/*
	 * ʎqړxW
	 */

	/* FUNCTW & FILTD & DELAY */
	/* lłȂԂ̒iKʔ{XV */
	state_ptr->yu = y + ((wi - y) >> 5);

	/* LIMB */
	if (state_ptr->yu < 544)		/* 544yu5120 */
		state_ptr->yu = 544;
	else if (state_ptr->yu > 5120)
		state_ptr->yu = 5120;

	/* FILTE & DELAY */
	/* lȏԂ̒iKʔ{XV */
	state_ptr->yl += state_ptr->yu + ((-state_ptr->yl) >> 6);

	/*
	 * K\W
	 */
	if (tr == 1) {				/* ϕMɑ΂abؾ
		state_ptr->a[0] = 0;
		state_ptr->a[1] = 0;
		state_ptr->b[0] = 0;
		state_ptr->b[1] = 0;
		state_ptr->b[2] = 0;
		state_ptr->b[3] = 0;
		state_ptr->b[4] = 0;
		state_ptr->b[5] = 0;
	} else {					/* abXV */
		pks1 = pk0 ^ state_ptr->pk[0];		/* UPA2 */

		/* \a[1]XV */
		a2p = state_ptr->a[1] - (state_ptr->a[1] >> 7);
		if (dqsez != 0) {
			fa1 = (pks1) ? state_ptr->a[0] : -state_ptr->a[0];
			if (fa1 < -8191)				/* a2p=fa1̏ */
				a2p -= 0x100;
			else if (fa1 > 8191)
				a2p += 0xFF;
			else
				a2p += fa1 >> 5;

			if (pk0 ^ state_ptr->pk[1])
				/* LIMC */
				if (a2p <= -12160)
					a2p = -12288;
				else if (a2p >= 12416)
					a2p = 12288;
				else
					a2p -= 0x80;
			else if (a2p <= -12416)
				a2p = -12288;
			else if (a2p >= 12160)
				a2p = 12288;
			else
				a2p += 0x80;
		}

		/* TRIGB & DELAY */
		state_ptr->a[1] = a2p;

		/* UPA1 */
		/* \aa[0]XV */
		state_ptr->a[0] -= state_ptr->a[0] >> 8;
		if (dqsez != 0)
			if (pks1 == 0)
				state_ptr->a[0] += 192;
			else
				state_ptr->a[0] -= 192;

		/* LIMD */
		a1ul = 15360 - a2p;
		if (state_ptr->a[0] < -a1ul)
			state_ptr->a[0] = -a1ul;
		else if (state_ptr->a[0] > a1ul)
			state_ptr->a[0] = a1ul;

		/* UPB:\_b[6]XV */
		for (cnt = 0; cnt < 6; cnt++) {
			if (code_size == 5)									/* 40kbps G.723p */
				state_ptr->b[cnt] -= state_ptr->b[cnt] >> 9;
			else												/* G.72124kbps G.723p */
				state_ptr->b[cnt] -= state_ptr->b[cnt] >> 8;
			if (dq & 0x7FFF) {									/* XOR */
				if ((dq ^ state_ptr->dq[cnt]) >= 0)
					state_ptr->b[cnt] += 128;
				else
					state_ptr->b[cnt] -= 128;
			}
		}
	}

	for (cnt = 5; cnt > 0; cnt--)
		state_ptr->dq[cnt] = state_ptr->dq[cnt-1];

	state_ptr->dq[0] = dq;

	state_ptr->sr[1] = state_ptr->sr[0];

	state_ptr->sr[0] = sr;

	/* DELAY A */
	state_ptr->pk[1] = state_ptr->pk[0];
	state_ptr->pk[0] = pk0;

	/* TONE */
	if (tr == 1)			/* ̎ްƂĈ܂B */
		state_ptr->td = 0;	/* ͉̂̂ƂĈ܂B */
	else if (a2p < -11776)	/* Ԃ̑ւ΁A */
		state_ptr->td = 1;	/* Mް܂B */
	else					/* łȂΐM͉łB */
		state_ptr->td = 0;

	
	/*
	 * Kx
	 */
	state_ptr->dms += (fi - state_ptr->dms) >> 5;			/* FILTA */
	state_ptr->dml += (((fi << 2) - state_ptr->dml) >> 7);	/* FILTB */

	if (tr == 1)
		state_ptr->ap = 256;
	else if (y < 1536)										/* SUBTC */
		state_ptr->ap += (0x200 - state_ptr->ap) >> 4;
	else if (state_ptr->td == 1)
		state_ptr->ap += (0x200 - state_ptr->ap) >> 4;
	else if (abs((state_ptr->dms << 2) - state_ptr->dml) >=
	    (state_ptr->dml >> 3))
		state_ptr->ap += (0x200 - state_ptr->ap) >> 4;
	else
		state_ptr->ap += (-state_ptr->ap) >> 4;
}

/*
 * tandem_adjust(sr, se, y, i, sign)
 *
 * ADPCM̍ŌŁAcƂĂ̏̕o͂󂯎邱Ƃł镄
 * ЭڰĂ܂BЭڰĂ̏o͂̕ւ̓͂ƈႦ΁A
 * o͂A-low܂̓-low̕1قɂĒ܂B
 *
 * :
 *	sr		o͒PCM
 *	se		\\z
 *	y		ʎqiK
 *	i		͕
 *	sign	i̕ޯ
 *
 * Ԃ:
 *	ꂽA-law܂̓-lawk
 */
int
tandem_adjust_alaw(
	int sr,				/* o͒PCM */
	int se,				/* \\z */
	int y,				/* ʎqiK */
	int i,				/* ͕ */
	int sign,
	short *qtab)
{
	unsigned char sp;	/* A-lawkꂽ8ޯĕ */
	short dx;			/* \덷 */
	char id;			/* ʎqꂽ\덷 */
	int sd;				/* ꂽA-lawl */
	int im;				/* i̕΂炳ꂽ傫 */
	int imx;			/* id̕΂炳ꂽ傫 */

	if (sr <= -32768)
		sr = -1;
	sp = linear2alaw((sr >> 1) << 3);	/* A-lawkk */
	dx = (alaw2linear(sp) >> 2) - se;	/* 16ޯė\덷 */
	id = quantize(dx, y, qtab, sign - 1);

	if (id == i) {						/* spł̒ȂŁA */
		return (sp);
	} else {							/* spKvŁA */
		/* ADPCM:8,9,...F,0,1,...,6,7 */
		im = i ^ sign;					/* ΂蕄̂߂2̕␔擾 */
		imx = id ^ sign;

		if (imx > im) {					/* ̂Ⴂl̂߂sp */
			if (sp & 0x80) {
				sd = (sp == 0xD5) ? 0x55 :
				    ((sp ^ 0x55) - 1) ^ 0x55;
			} else {
				sd = (sp == 0x2A) ? 0x2A :
				    ((sp ^ 0x55) + 1) ^ 0x55;
			}
		} else {						/* ̂荂l̂߂sp */
			if (sp & 0x80)
				sd = (sp == 0xAA) ? 0xAA :
				    ((sp ^ 0x55) + 1) ^ 0x55;
			else
				sd = (sp == 0x55) ? 0xD5 :
				    ((sp ^ 0x55) - 1) ^ 0x55;
		}
		return (sd);
	}
}

int
tandem_adjust_ulaw(
	int sr,				/* o͒PCM */
	int se,				/* \\z */
	int y,				/* ʎqiK */
	int i,				/* ͕ */
	int sign,
	short *qtab)
{
	unsigned char sp;	/* -lawkꂽ8ޯĕ */
	short dx;			/* \덷 */
	char id;			/* ʎqꂽ\덷 */
	int sd;				/* ꂽ-lawl */
	int im;				/* i̕΂炳ꂽ傫 */
	int imx;			/* id̕΂炳ꂽ傫 */

	if (sr <= -32768)
		sr = 0;
	sp = linear2ulaw(sr << 2);			/* -lawkk */
	dx = (ulaw2linear(sp) >> 2) - se;	/* 16ޯė\덷 */
	id = quantize(dx, y, qtab, sign - 1);
	if (id == i) {
		return (sp);
	} else {
		/* ADPCM:8,9,...F,0,1,...,6,7 */
		im = i ^ sign;					/* ΂蕄̂߂2̕␔擾 */
		imx = id ^ sign;
		if (imx > im) {					/* ̂Ⴂl̂߂sp */
			if (sp & 0x80)
				sd = (sp == 0xFF) ? 0x7E : sp + 1;
			else
				sd = (sp == 0) ? 0 : sp - 1;

		} else {						/* ̂荂l̂߂sp */
			if (sp & 0x80)
				sd = (sp == 0x80) ? 0x80 : sp - 1;
			else
				sd = (sp == 0x7F) ? 0xFE : sp + 1;
		}
		return (sd);
	}
}
